#include  "device.h"


#include  <getopt.h>


//=[ Typedefs/Structures/Enums ]================================================


//=[ Variables ]================================================================

// Command line options.
//
struct option  optionList[] = 
{
    { "help",		no_argument,		NULL,	'h' },
    { "quiet",		no_argument,		NULL,	'q' },
    { "verbose",	no_argument,		NULL,	'v' },

    { NULL,		no_argument,		NULL,	 0 }
};
#define  SHORT_OPTIONS  "hiqv"


int  verboseLevel = 1;

//=[ Entry Point ]==============================================================

int main( int argc, char** argv, char** envp )
{
  int   exitCode = 0;				// Exit code.
  int   shortOption = 0;			// Short option value.
  int   longOption = 0;			// Long option value.

  while( EOF != (shortOption = getopt_long( argc, argv, SHORT_OPTIONS,
      optionList, &longOption )) )
  {
    switch( shortOption )
    {
      // *** HELP ***
      //
      case  'h':
	printf( "Usage: device [--help | --init | --verbose | --quiet]\n" );
	exit( 0 );
	break;

      // *** QUIET ***
      //
      case  'q':
	verboseLevel = 0;
	break;

      // *** VERBOSE ***
      //
      case  'v':
	verboseLevel++;
	break;
    }
  }
  
  if( 0 == exitCode )
  {
    exitCode = device_main( argc, argv );
  }

  return( exitCode );
}

/* vim:set shiftwidth=2: */
