//~~ diff.c ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
/*
 *  Compute a diff of two files.
 *
 * @author:    Andy Pippin   <pippin@cs.ucsb.edu>
 * @version:   $Date: 2005/02/21 03:28:11 $   $Revision: 1.1 $
 * @requires:   
 */

//~~[ Identity ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#define  __DIFF_C__
static char* srcIdentity = 
    "$Id: diff.c,v 1.1 2005/02/21 03:28:11 pippin Exp $";


//~~[ Includes ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#include  <errno.h>
#include  <stdio.h>

#include  "diff.h"
#include  "error.h"


//~~[ Typedefs/Structures/Enums ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

//~~[ Constants ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

static const char* DIFF_CMD = "diff --minimal --unified=0 %s %s";


//~~[ Variables ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

//~~[ Prototypes ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

    //----------------------------------------------------------------------
    /*
     *  description
     *
     * @param   arg   description
     * @param   arg   description
     * @return  returns
     */


//~~[ Implementation ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	extern LOG*
diff_locate(
    HASH   parentId,
    char*  fileName,
    LOG*   prevInner,
    char*  before,
    char*  after
){
    if( (NULL != before) && (NULL != after) )
    {
        char diffCmd[ 2*FILENAME_MAX ];
	snprintf( diffCmd, sizeof(diffCmd), DIFF_CMD, before, after );
        FILE* diff;
debug( __FILE__, __LINE__, "diff_locate()'diffCmd=\"%s\"\n", diffCmd );

        if( NULL != (diff = popen( diffCmd, "r" )) )
	{
	    char buffer[ BUFSIZ ];
	    int bytes;
	    while( 0 < (bytes = fread( buffer, sizeof(char), BUFSIZ, diff )) )
	    {
	        fwrite( buffer, sizeof(char), bytes, stdout );
	    }

	    pclose( diff );
	}

#ifndef NDEBUG
	else
	{
	    error( "Couldn't create \"%s\": %s\n", diffCmd, strerror( errno ) );
	}
#endif // NDEBUG
    }
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
