//~~ diff.h ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
/*
 *  Compute a diff of two files.
 *
 * @author:    Andy Pippin   <pippin@cs.ucsb.edu>
 * @version:   $Date: 2005/02/21 03:28:11 $   $Revision: 1.1 $
 * @requires:  *nix.
 */

//~~[ Identity ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#ifndef  __DIFF_H__
#define  __DIFF_H__

#ifdef __DIFF_C__
static char* hdrIdentity =
    "$Id: diff.h,v 1.1 2005/02/21 03:28:11 pippin Exp $";
#endif

#ifdef __cplusplus
extern "C" {
#endif

//~~[ Includes ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#include  "log.h"


//~~[ Typedefs/Structures/Enums ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

//~~[ Constants ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

//~~[ Variables ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

//~~[ Prototypes ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

//------------------------------------------------------------------------------
/*
 *  Locate the changes in a file.  Only deals with text files right now.
 *
 * @param   parentId    The parent of this entry.
 * @param   fileName    The name of the file to log.
 * @param   prevInner   Previous inner log entry.
 * @param   before   The name of the file before the change.
 * @param   after    The name of the file after the change.
 * @return  A sequence of log messages.
 */
	extern LOG*
diff_locate(
    HASH   parentId,
    char*  fileName,
    LOG*   prevInner,
    char*  before,
    char*  after
);


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#ifdef __cplusplus
}
#endif
#endif // __DIFF_H__
