//~~ error.c ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
/*
 *  description
 *
 * @author:    Andy Pippin   <pippin@cs.ucsb.edu>
 * @version:   $Date: 2005/02/21 03:28:11 $   $Revision: 1.3 $
 * @requires:   
 */

//~~[ Identity ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#define  __ERROR_C__
static char* srcIdentity = 
    "$Id: error.c,v 1.3 2005/02/21 03:28:11 pippin Exp $";


//~~[ Includes ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#include  <stdio.h>
#include  <stdarg.h>

#include  "error.h"


//~~[ Typedefs/Structures/Enums ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

//~~[ Constants ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

//~~[ Variables ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

//~~[ Prototypes ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

    //----------------------------------------------------------------------
    /*
     *  description
     *
     * @param   arg   description
     * @param   arg   description
     * @return  returns
     */


//~~[ Implementation ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	void
error(
    const char* fmt,
    ...
){
    va_list  argList;

    if( NULL != fmt )
    {
	va_start( argList, fmt );

	fflush( stdout );
	fprintf( stderr, "[ERROR]  " );
	vfprintf( stderr, fmt, argList );
	fflush( stderr );

	va_end( argList );
    }

    return;
}


//------------------------------------------------------------------------------

	int
debug(
    const char* file,
    int const   line,
    const char* fmt,
    ...
){
// Only if NDEBUG has not been defined.
#ifndef NDEBUG

    va_list  argList;

    if( NULL == file )
    {
        file = "???";
    }

    if( NULL != fmt )
    {
	va_start( argList, fmt );

	fflush( stdout );
	fprintf( stderr, "DEBUG [%s:%d]  ", file, line );
	vfprintf( stderr, fmt, argList );
	fflush( stderr );

	va_end( argList );
    }

#endif // NDEBUG

    return( !0 );
}


//------------------------------------------------------------------------------
	
	int
debug1(
    const char* fmt,
    ...
){
// Only if NDEBUG has not been defined.
#ifndef NDEBUG

    va_list  argList;

    if( NULL != fmt )
    {
	va_start( argList, fmt );

	fflush( stdout );
	fprintf( stderr, "[DEBUG]  " );
	vfprintf( stderr, fmt, argList );
	fflush( stderr );

	va_end( argList );
    }

#endif // NDEBUG

    return( !0 );
}


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
