//~~ error.h ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
/*
 *  description
 *
 * @author:    Andy Pippin   <pippin@cs.ucsb.edu>
 * @version:   $Date: 2005/02/21 03:28:11 $   $Revision: 1.3 $
 * @requires:   
 */

//~~[ Identity ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#ifndef  __ERROR_H__
#define  __ERROR_H__

#ifdef __ERROR_C__
static char* hdrIdentity =
    "$Id: error.h,v 1.3 2005/02/21 03:28:11 pippin Exp $";
#endif

#ifdef __cplusplus
extern "C" {
#endif

//~~[ Includes ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#include  <stdio.h>
#include  <stdarg.h>


//~~[ Typedefs/Structures/Enums ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

//~~[ Constants ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

//~~[ Variables ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

//~~[ Prototypes ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

//------------------------------------------------------------------------------
/*
 *  Display message prepended with "[ERROR] "
 *
 * @param   fmt   *printf() format command
 * @param   ...   argument list
 */
	void
error(
    const char* fmt,
    ...
);


//------------------------------------------------------------------------------
/*
 *  Display message prepended with "DEBUG [<file>:<line>] "
 *
 * @param   file  Name of the file (usually from __FILE__).
 * @param   line  Line number (usually from __LINE__).
 * @param   fmt   *printf() format command
 * @param   ...   argument list
 * @return  True (!0).
 */
	extern int
debug(
    const char* file,
    int const   line,
    const char* fmt,
    ...
);

//------------------------------------------------------------------------------
/*
 *  Display message prepended with "DEBUG "
 *
 * @param   fmt   *printf() format command
 * @param   ...   argument list
 * @return  True (!0).
 */
	extern int
debug1(
    const char* fmt,
    ...
);


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#ifdef __cplusplus
}
#endif
#endif // __ERROR_H__
