//~~ misc.c ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
/*
 *  description
 *
 * @author:    Matt Sun   <mattsun@cs.ucsb.edu>
 * @version:   $Date: 2005/10/23 05:42:50 $   $Revision: 1.9 $
 * @requires:   
 */

//~~[ Identity ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#define  __MISC_C__
static char* srcIdentity = 
    "$Id: misc.c,v 1.9 2005/10/23 05:42:50 mattsun Exp $";


//~~[ Includes ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#include  <errno.h>
#include  <stdio.h>
#include  <stdlib.h>
#include  <stdint.h>
#include  <sys/types.h>
#include  <sys/stat.h>
#include  <time.h>
#include  <unistd.h>

#include  "misc.h"
#include  "device/device.h"
#include  "qfs/user_data.h"


//~~[ Typedefs/Structures/Enums ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

//~~[ Constants ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

//~~[ Variables ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

//~~[ Prototypes ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

    //----------------------------------------------------------------------
    /*
     *  description
     *
     * @param   arg   description
     * @param   arg   description
     * @return  returns
     */


//~~[ Implementation ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	int
misc_getFileStatus(
    char* filename,
    time_t  lastChanged
){
    int exitCode = 0;
    struct stat  statBuffer;
    struct stat  statbuffer;
    char  nameBuffer[ FILENAME_MAX ];
    char* ptr;

    misc_getFileName( filename, nameBuffer, FILENAME_MAX );

    if( -1 == stat( nameBuffer, &statBuffer ) )
    {
        if( ENOENT == errno )
	{
	    exitCode = (int)'?';
	}
	else
	{
	    exitCode = -errno;
	}
    }
    else if( lastChanged < statBuffer.st_mtime )
    {
        exitCode = (int)'*';
    }
    else
    {
        exitCode = (int)' ';
    }

    return( exitCode );
}


//------------------------------------------------------------------------------

	char*
misc_getFileName(
    char* filename,
    char* buffer,
    int  maxSize
){
    static char internal[ FILENAME_MAX ];
    char* result;
    char* ptr;
    int size;

    if( (NULL == buffer) || (0 == maxSize) )
    {
        result = internal;
	size = FILENAME_MAX;
    }
    else
    {
        result = buffer;
	size = maxSize;
    }


    /*
    if( NULL == filename )
    {
        *result = '\0';
    }
    else if( NULL != (ptr = getenv( "QUARTZ_HOME" )) )
    {
        snprintf( result, size, "%s/%s", ptr, filename );
    }
    else if( NULL != (ptr = getenv( "HOME" )) )
    {
      //      fprintf(stderr, "ptr = %s, filename = %s\n", ptr, filename);
        snprintf( result, size, "%s/%s", ptr, filename );
    }
    else
    {
    */
        strncpy( result, filename, size );
	//}

    return( result );
}


//------------------------------------------------------------------------------

	char*
misc_getKeyPassword(
    void
){
    //         Q  u  @  r  t  z  a  R  0  n  !
    // Hex:   51 75 40 72 74 7A 61 52 30 6E 21
    // shift: D1 F5 C0 F2 F4 FA E1 D2 B0 EE A1

	  /*
	  static uint8_t password[11] =
	    { 0xA1, 0xEE, 0xB0, 0xD2, 0xE1, 0xFA, 0xF4, 0xF2, 0xC0, 0xF5, 0xD1 };
	  */
	  
	  /*
    char passwd[16];
    memset(passwd, '\0', 15);
    
    strncpy(passwd, deviceInfo->password, 13);

    fprintf(stderr, "deviceInfo->password = %s\n", deviceInfo->password);
    fprintf(stderr, "passwd = %s\n", passwd);
	  */

    return deviceInfo->password;
}


//------------------------------------------------------------------------------

	char*
misc_getKeyFilename()
{
  static char keyBuffer[ FILENAME_MAX ] = { '\0' };
  static char* keyFilename = NULL;
  
  if( NULL == keyFilename )
  {
    get_config_file( "key", keyBuffer, FILENAME_MAX );
    keyFilename = keyBuffer;
  }
  
  return( keyFilename );
}


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
