//~~ misc.h ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
/*
 *  description
 *
 * @author:    Andy Pippin   <pippin@cs.ucsb.edu>
 * @version:   $Date: 2005/03/07 06:12:07 $   $Revision: 1.2 $
 * @requires:   
 */

//~~[ Identity ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#ifndef  __MISC_H__
#define  __MISC_H__

#ifdef __MISC_C__
static char* hdrIdentity =
    "$Id: misc.h,v 1.2 2005/03/07 06:12:07 pippin Exp $";
#endif

#ifdef __cplusplus
extern "C" {
#endif

//~~[ Includes ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

//~~[ Typedefs/Structures/Enums ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

//~~[ Constants ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

//~~[ Variables ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

//~~[ Prototypes ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

//------------------------------------------------------------------------------
/*
 *  Get the file status.  if successful, the code will be:
 *	'?'  File not found.
 *      '*'  Out of date.
 *      ' '  Up to date (space).
 *
 * @param   filename     The name of the file.
 * @param   lastChanged  The last recorded change timestamp.
 * @return  On success, a status code, on failure the negative of the error code
 */
	extern int
misc_getFileStatus(
    char* filename,
    time_t  lastChanged
);


//------------------------------------------------------------------------------
/*
 *  Get the "real" file name.
 *
 * @param   filename  The name of the file relative to QUARTZ_HOME.
 * @param   buffer    A buffer to put the name into (NULL --> use local).
 * @param   maxSize   size of the buffer (0 --> use local).
 * @return  The name of the file on the filesystem.
 */
	extern char*
misc_getFileName(
    char* filename,
    char* buffer,
    int  maxSize
);


//------------------------------------------------------------------------------
/*
 *  Get the password of the key.
 */
	char*
misc_getKeyPassword(
    void
);


//------------------------------------------------------------------------------
/*
 *  Get the filename of the key.
 */
	char*
misc_getKeyFilename(
    void
);


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#ifdef __cplusplus
}
#endif
#endif // __MISC_H__
