//~~ net.h ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
/*
 *  description
 *
 * @author:    Andy Pippin   <pippin@cs.ucsb.edu>
 * @version:   $Date: 2005/02/28 23:25:33 $   $Revision: 1.2 $
 * @requires:   
 */

//~~[ Identity ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#ifndef  __NET_H__
#define  __NET_H__

#ifdef __NET_C__
static char* hdrIdentity =
    "$Id: net.h,v 1.2 2005/02/28 23:25:33 mattsun Exp $";
#endif

#ifdef __cplusplus
extern "C" {
#endif

//~~[ Includes ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

//~~[ Typedefs/Structures/Enums ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

typedef enum _protocol
{
    NET_TCP,
    NET_UDP,
    NET_ICMP
}
  PROTOCOL;


//~~[ Constants ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

//~~[ Variables ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

//~~[ Prototypes ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

//------------------------------------------------------------------------------
/*
 *  description
 *
 * @param   arg   description
 * @param   arg   description
 * @return  returns
 */
        int
net_connect(
    const char*  addr,
    PROTOCOL  protocol,
    int timeout
);


//------------------------------------------------------------------------------
/*
 *  description
 *
 * @param   arg   description
 * @param   arg   description
 * @return  returns
 */
        int
net_accept(
    int socket,
    int queue
);


//------------------------------------------------------------------------------
/*
 *  description
 *
 * @param   arg   description
 * @param   arg   description
 * @return  returns
 */
        int
net_bind(
    int socket,
    int port
);


//------------------------------------------------------------------------------
/*
 *  description
 *
 * @param   arg   description
 * @param   arg   description
 * @return  returns
 */
        int
net_send(
    int socket,
    void* buffer,
    int  bytes 
);


//------------------------------------------------------------------------------
/*
 *  description
 *
 * @param   arg   description
 * @param   arg   description
 * @return  returns
 */
        int
net_recv(
    int socket,
    int timeout,
    void* buffer,
    int  maxBytes 
);

//------------------------------------------------------------------------------
/*
 *  description
 *
 * @param   arg   description
 * @param   arg   description
 * @return  returns
 */
        int
net_get_port(
    int base_port
);

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#ifdef __cplusplus
}
#endif
#endif // __NET_H__
