/*********************
 * used to retrieve user data from binary file
 *********************/

#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <time.h>
#include <chimera.h>

/* ------------- STRUCTURES--------------- */

// will hold all user information some of which can
// be retrieved for performance and usage statistics
typedef struct _struct_user_data_z
{
  char username[64];
  Key key;
  struct tm  start_date;
  u_int8_t   password[11];
  u_int32_t  signons;
  u_int32_t  signoffs;
  u_int32_t  groups;
  u_int32_t  files;
  u_int32_t  size;
  u_int32_t  received;
  u_int32_t  sent;
  u_int32_t  commits;
  u_int32_t  updates;
  u_int32_t  file_inodes;
  u_int32_t  file_size;
} _user_data_z;


/* ------------- FUNCTIONS --------------- */

extern int user_data_read(_user_data_z **data);
extern int user_data_init();
extern int user_set_username(char *name);
extern int user_set_key(Key key);
extern int user_set_password(u_int8_t new_passwd[11]);
extern u_int8_t* user_get_password();
extern int user_incr_signons();
extern int user_incr_signoffs();
extern int user_incr_groups(int add);
extern int user_incr_files(int add);
extern int user_incr_size(u_int32_t size, int add);
extern int user_incr_recv();
extern int user_incr_sent();
extern int user_incr_commits();
extern int user_incr_updates();
extern int user_incr_file_inodes(int add);
extern int user_incr_file_size(u_int32_t size, int add);
extern int user_set_start_date(struct tm *date);
extern int user_get_file_size();
extern int user_set_file_size(u_int32_t size);


