/*
    Sample test file that shows how to interface
    with quartz_rsa and the modified openssl library 
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "quartz_rsa.h"

#define NEWKEY 	200
#define ENCRYPT 201
#define DECRYPT 202


void usage()
{
    printf("Three ways to run this test program:\n");
    printf("executable N keyfile password                <-- generate a key and put in keyfile\n");
    printf("executable E keyfile password infile outfile <-- encrypt infile to outfile using keyfile\n"); 
    printf("executable D keyfile password infile outfile <-- decrypt infile to outfile using keyfile\n");
}

int main(int argc, char **argv)
{
    int action = -1;
  
    /* check arguments */
    if ((argc==4)&&(strcmp(argv[1],"N")==0)){
	    action = NEWKEY;
	}
    else if ((argc==6)&&(strcmp(argv[1],"E")==0)){
	    action = ENCRYPT;
	}
    else if ((argc==6)&&(strcmp(argv[1],"D")==0)){
	    action = DECRYPT;
	}
    else{
	    usage();
	    return -1;
	}	
	
    /*** perform crypt action ***/
    switch(action)
	{
	case NEWKEY:{
	    quartz_generate_key(argv[2], argv[3]);		
	    break;
	    }
	case ENCRYPT:{
	    quartz_encrypt_file(argv[2], argv[3], argv[4], argv[5]);
	    break;
	    }
	case DECRYPT:
	    quartz_decrypt_file(argv[2], argv[3], argv[4], argv[5]);
	default:
	    break;
	}
			
    return 0;
}
