/*== cgi.cc ==================================================================*\
|*									      *|
|*  CGI library. 							      *|
|*									      *|
|* @author   $Author: pippin $				      *|
|* @version  $Revision: 1.1 $  $Date: 2005/02/07 23:29:47 $		      *|
|*									      *|
\*============================================================================*/


//==[ Identity ]================================================================

#define  __CGI_CC__
static char* srcIdentity = 
    "$Id: cgi.c,v 1.1 2005/02/07 23:29:47 pippin Exp $";


//==[ Includes ]================================================================

#include <stdlib.h>
#include "cgi.h"


//==[ Typedefs/Structures/Enums ]===============================================

//==[ Constants ]===============================================================

//==[ Variables ]===============================================================

extern int  verboseLevel;
static cgi_ITEM*  cgi_itemList = NULL;


//==[ Classes ]=================================================================

//==[ Prototypes ]==============================================================

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
/*
 *  description
 *
 * @param   arg   description
 * @param   arg   description
 * @return  returns
 */
	static void
cgi_getAndDisplay(
    const char* environmentalVariable
);


//==[ Implementation ]==========================================================

	void
cgi_test(
    void
){
    cgi_ITEM*  queryItem = NULL;

    printf( "Content-type: text/html\r\n\r\n" );
    printf( "<HTML>\r\n" );
    printf( "<HEAD>\r\n" );
    printf( "  <TITLE>Test</TITLE>\r\n" );
    printf( "<HEAD>\r\n" );
    printf( "<BODY>\r\n" );
    printf( "Environment variables:<OL>\r\n" );

    cgi_getAndDisplay( "SERVER_SOFTWARE" );
    cgi_getAndDisplay( "SERVER_NAME" );
    cgi_getAndDisplay( "GATEWAY_INTERFACE" );
    cgi_getAndDisplay( "SERVER_PROTOCOL" );
    cgi_getAndDisplay( "SERVER_PORT" );
    cgi_getAndDisplay( "REQUEST_METHOD" );
    cgi_getAndDisplay( "HTTP_ACCEPT" );
    cgi_getAndDisplay( "PATH_INFO" );
    cgi_getAndDisplay( "PATH_TRANSLATED" );
    cgi_getAndDisplay( "SCRIPT_NAME" );
    cgi_getAndDisplay( "QUERY_STRING" );
    cgi_getAndDisplay( "REMOTE_HOST" );
    cgi_getAndDisplay( "REMOTE_ADDR" );
    cgi_getAndDisplay( "REMOTE_USER" );
    cgi_getAndDisplay( "AUTH_TYPE" );
    cgi_getAndDisplay( "CONTENT_TYPE" );
    cgi_getAndDisplay( "CONTENT_LENGTH" );

    printf( "</UL>\r\n" );

    if( NULL != (queryItem = cgi_getQuery()) ) {
        printf( "<BR>Query:<BR>\r\n" );
        printf( "<BLOCKQUOTE>\r\n" );
        printf( "<TABLE>\r\n" );
	printf( "  <TR>\r\n" );
	printf( "    <TH>Key</TH>\r\n" );
	printf( "    <TH>Val</TH>\r\n" );
	printf( "  </TR>\r\n" );

	while( NULL != queryItem ) {
	    printf( "  <TR>\r\n" );
	    printf( "    <TD>%s</TD>\r\n", queryItem->key );
	    printf( "    <TD>%s</TD>\r\n", queryItem->val );
	    printf( "  </TR>\r\n" );
	    queryItem = queryItem->next;
	}
        printf( "</TABLE>\r\n" );
        printf( "</BLOCKQUOTE>\r\n" );
    }

    printf( "</BODY>\r\n</HTML>\r\n" );
    return;
}


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	cgi_ITEM*
cgi_getQuery(
    void
){
    static char buffer[ 1024 ];
    const char* result = NULL;
    cgi_ITEM* firstItem = NULL;

    const char*  requestMethod = getenv( "REQUEST_METHOD" );

	
    if( NULL == requestMethod ) {
        fflush( stdout );
	fprintf( stderr, "You forgot to specify the REQUEST_METHOD!\n" );
        fflush( stderr );
		
    } else if( 0 == strcasecmp( requestMethod, "post" ) ) {
        int bytesToRead = atoi( getenv( "CONTENT_LENGTH" ) );
		int bytesRead = 0;
		int read;
		while( bytesRead < bytesToRead ) {
			read = fread( buffer+bytesRead, 1, bytesToRead-bytesRead, stdin );
			if( 0 > read ) {
				break;
			} else {
				bytesRead += read;
			}
		}
		result = buffer;
    } else if( 0 == strcasecmp( getenv( "REQUEST_METHOD" ), "get" ) ) {
        char* queryString = getenv( "QUERY_STRING" );
	if( NULL == queryString )
	{
	    fflush( stdout );
	    fprintf( stderr, "You forgot to specify the QUERY_STRING!\n" );
	    fflush( stderr );
	}
	else 
	{
	    strncpy( buffer, getenv( "QUERY_STRING" ), sizeof( buffer ) );
	    result = buffer;
	}
    }

    if( NULL != buffer ) {
	cgi_ITEM* curr = firstItem = (cgi_ITEM*)malloc( sizeof(cgi_ITEM) );
	memset( curr, 0, sizeof(cgi_ITEM) );

	char* ptr = buffer;

	do {
	    curr->key = ptr;
	    curr->val = NULL;
	    curr->next = NULL;

	    for( ; '\0' != *ptr; ++ptr ) {
	        if( '=' == *ptr ){
		    *ptr = '\0';
		    curr->val = ++ptr;
		    break;
		}
	    }
	    if( '\0' != *ptr ) {
		for( ; '\0' != *ptr; ++ptr ) {
		    if( '&' == *ptr ){
			*(ptr++) = '\0';
			cgi_ITEM* newItem = (cgi_ITEM*)malloc(sizeof(cgi_ITEM));
			memset( curr, 0, sizeof(cgi_ITEM) );
			curr->next = newItem;
			curr = newItem;
			break;
		    }
		}
	    }
	}
	while( ('\0' != *ptr) && (NULL != curr) );
    }

    cgi_itemList = firstItem;
    return( firstItem );
}


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	const char*
cgi_getValue(
    const char* key
){
    const char* value = NULL;

    if( NULL == cgi_itemList ) {
        cgi_itemList = cgi_getQuery();
    }
    cgi_ITEM* item = cgi_itemList;

    if( (NULL != item) && (NULL != key) ) {
        do {
	    if( 0 == strcmp( key, item->key ) ) {
	        value = item->val;
		break;
	    } else {
		item = item->next;
	    }
	} while( NULL != item );
    }

    return( value );
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	void
cgi_dumpItem(
    cgi_ITEM* item,
    const char* label,
    FILE* out
){
    if( NULL != item ) {
	out = (NULL == out) ? stdout : out;

	if( NULL != label ) {
	    fprintf( out, "%s: ", label );
	}
	fprintf( out, "item = 0x%x\n", item );

	if( NULL != item->key ) {
	    fprintf( out, "item->key= \"%s\"\n", item->key );
	} else {
	    fprintf( out, "item->key= NULL\n", item->key );
	}

	if( NULL != item->val ) {
	    fprintf( out, "item->val= \"%s\"\n", item->val );
	} else {
	    fprintf( out, "item->val= NULL\n" );
	}

	fprintf( out, "item->next= 0x%x\n", item->next );
	fprintf( out, "\n" );
    }
}


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	static void
cgi_getAndDisplay(
    const char* environmentalVariable
){
    if( NULL != environmentalVariable ) {
        char* value = getenv( environmentalVariable );
	if( NULL != value ) {
	    printf( "<LI>%s = \"%s\"</LI>\n", environmentalVariable, value );
	} else {
	    printf( "<LI>%s = NULL</LI>\n", environmentalVariable );
	}
    }
}

//==============================================================================
