/*== cgi.h ===================================================================*\
|*									      *|
|*  CGI functions.							      *|
|*									      *|
|* @author   $Author: pippin $				      *|
|* @version  $Revision: 1.1 $  $Date: 2005/02/07 23:29:47 $		      *|
|*									      *|
\*============================================================================*/

#ifndef  __CGI_H__
#define  __CGI_H__

#ifdef __CGI_C__
static char* hdrIdentity =
    "$Id: cgi.h,v 1.1 2005/02/07 23:29:47 pippin Exp $";
#endif


//==[ Includes ]================================================================

#include  <stdio.h>


//==[ Typedefs/Structures/Enums ]===============================================

typedef struct _item_s {
  const char*  key;
  const char*  val;
  struct _item_s*  next;
}
  cgi_ITEM;


//==[ Constants ]===============================================================

//==[ Variables ]===============================================================

//==[ Prototypes ]==============================================================

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
/**
 *  Test this class.
 */
	extern void
cgi_test(
    void
);


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
/**
 *  Get the query key/value pairs.
 *
 * @return   The query key/value pairs, or NULL if none.
 */
	extern cgi_ITEM*
cgi_getQuery(
    void
);



//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
/**
 *  Get a value.
 */
	extern const char*
cgi_getValue(
    const char* key
);


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
/**
 *  Dump an ITEM.
 *
 * @param  item  The item to display.
 * @param  label Prefix to text.
 * @param  out   The file to which to display the item.
 */
	extern void
cgi_dumpItem(
    cgi_ITEM* item,
    const char* label,
    FILE* out
);


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#endif // __CGI_H__
