/*== html.h ==================================================================*\
|*									      *|
|*  HTML Functions.							      *|
|*									      *|
|* @author   $Author: pippin $						      *|
|* @version  $Revision: 1.1 $  $Date: 2005/02/07 23:29:47 $		      *|
|*									      *|
\*============================================================================*/

#ifndef  __HTML_H__
#define  __HTML_H__

#ifdef __HTML_C__
static char* hdrIdentity =
    "$Id: html.h,v 1.1 2005/02/07 23:29:47 pippin Exp $";
#endif


//==[ Includes ]================================================================

//==[ Typedefs/Structures/Enums ]===============================================

//==[ Constants ]===============================================================

//==[ Variables ]===============================================================

//==[ Classes ]=================================================================

//==[ Prototypes ]==============================================================

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
/**
 *  Create a response to a node request.
 *
 * @param  nodeName  The common name of the node.
 * @param  nodeName  The IP Address of the node.
 * @param  nodeHashString  The string representation of the hash.
 * @param  userName  The common name of the user.
 * @param  userEMail  The email for the user.
 * @param  userHashString  The hash identity string for the user.
 * @return Local buffer containing the result.
 */
	extern const char*
html_createNodeResponse(
    const char* nodeName,
    const char* nodeAddr,
    const char* nodeHash,
    const char* userName,
    const char* userEMail,
    const char* userHashString
);


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
/**
 *  Fix the string from a HTTP post/get byr converting %02X --> chars
 *  and '+' to spaces.
 *
 * @param  inputString  The string to fix.
 * @param  outputString  Output string buffer (NULL --> local)
 * @param  outputStringSize  Size of output string buffer (0 --> local).
 * 
 */
	extern const char*
html_fix(
    const char* inputString,
    char* outputString,
    int  outStringSize
);


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
/**
 *  Perform a test on html functions.
 *
 * @return  Success (0), or test # it failed on (>0).
 */
	extern int
html_test(
    void
);


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#endif // __HTML_H__
