/*
 *  sha1file.h
 *
 *  Description:
 *      An additional header file for the functions that create a SHA-1
 *	hash for the contents of a file.
 *
 *  Requires:
 *	sha1.h for SHA1Context structure.
 */

#ifndef _SHA1FILE_H_
#define _SHA1FILE_H_

#include  "sha1.h"


#ifdef __cplusplus
extern "C" {
#endif


#ifndef _SHAFILE_enum_
#define _SHAFILE_enum_
enum
{
    shaFileReadError = (shaFileError+1),
    shaFileOpenError,

    shaFileUnknown = shaFileError
};
#endif // _SHAFILE_enum_


/*
 *  Function Prototypes
 */

int SHA1FilePointer( SHA1Context*, FILE* );
int SHA1FileName( SHA1Context*, const char* );


#ifdef __cplusplus
}
#endif


#endif // _SHA1FILE_H_
