//~~ store.h ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
/*
 *  description
 *
 * @author:    Matt Sun   <mattsun@cs.ucsb.edu>
 * @version:   $Date: 2005/10/25 19:40:54 $   $Revision: 1.9 $
 * @requires:   
 */

//~~[ Identity ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#ifndef  __STORE_H__
#define  __STORE_H__

#include "libsha1.h"
#include "chimera.h"

#ifdef __STORE_C__
static char* hdrIdentity =
    "$Id: store.h,v 1.9 2005/10/25 19:40:54 mattsun Exp $";
#endif

#ifdef __cplusplus
extern "C" {
#endif


  /* init, registers chimera functions */
  extern int quartz_store_init();
  
  /* send an entry for storage */
  extern int quartz_store_send_entry( Key node_id, HASH user_id, char *group,
				      HASH group_id, HASH file_id, uint32_t version,
				      uint32_t size, uint8_t *data);

  /* send an entry for storage */
  extern int quartz_remove_entry( Key node_id, HASH user_id, char *group,
				  HASH group_id, HASH file_id, uint32_t version,
				  uint32_t size, uint8_t *data);

  /* send an entry for storage */
  extern int quartz_remove_group( Key node_id, HASH user_id, char *group, HASH group_id );

  /* gets an entry from storage */
  extern int quartz_store_get_entry( Key node_id, HASH user_id, Key group_key,
				     HASH group_id, HASH file_id, 
				     uint32_t version );

  /* gets an entry from storage */
  extern int quartz_store_get_group( Key node_id, HASH user_id, char *group,
				     HASH group_id, HASH file_id, 
				     uint32_t version );

  /* send meta data for storage */
  extern int quartz_store_send_meta( Key node_id, char* user_id, char* file_name,
				     char* group_name, char* group_id,
				     uint32_t version, uint32_t size);

  /* gets meta data from storage for the specified file */
  extern int quartz_store_get_meta( Key node_id, char* user_id, char* file_name,
				     char* group_name, char* group_id);

  /* gets meta data from storage for all in group */
  extern int quartz_store_get_metas( Key node_id, char* user_id, char* group_name,
				     char* group_id);

  /* chimera specific upcall functions */
  extern void quartz_store_upcall_del( Key *k, Message *m );


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#ifdef __cplusplus
}
#endif
#endif // __STORE_H__
