/*
 * ** $Id: host.h,v 1.5 2005/09/27 18:25:04 msa Exp $
 * **
 * ** Matthew Allen
 * ** description: 
 * */

#ifndef CHIMERA_HOST_H
#define CHIMERA_HOST_H

#include "key.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  char *name;
  unsigned long address;
  int failed;
  double failuretime;
  int port;
  double latency;
  double loss;
  double success;
  Key key;
} ChimeraHost;

/* host_get: hn, port
** gets a host entry for the given host, getting it from the cache if
** possible, or alocates memory for it */

ChimeraHost *host_get(char *hn, int port);

/* host_release: host
** releases a host from the cache, declaring that the memory could be
** freed any time. returns NULL if the entry is deleted, otherwise it
** returns #host# */

void host_release(ChimeraHost *host);

/* host_decode: s
** decodes a string into a chimera host structure. This acts as a
** host_get, and should be followed eventually by a host_release. */

ChimeraHost *host_decode(char *s);

/* host_encode: s, len, host
** encodes the #host# into a string, putting it in #s#, which has
** #len# bytes in it. */

void host_encode(char *s, int len, ChimeraHost *host);

/* host_init: size
** initialize a host struct with a #size# element cache. */

void host_init(int size);

#ifdef __cplusplus
}
#endif

#endif /* CHIMERA_HOST_H */
