#ifndef CHIMERA_JOB_QUEUE_H
#define CHIMERA_JOB_QUEUE_H

#ifdef __cplusplus
extern "C" {
#endif

typedef void (*FuncPtr)(void *);

/* job_queue node structure */
typedef struct node{
  FuncPtr fp;       /* pointer to function */
  void * args;      /* functioin arguement */
  struct node * next; 
} node;

/* queue_queue structure */
typedef struct{
  node * head;
  int size;
  pthread_mutex_t access;  
  pthread_cond_t empty; 
} List;


/* get the queue mutex #access# then
 * if the queue is emapty it would go to sleep and releas the mutex
 * else get the first job out of queue and execute ir */
void * job_exec(void *job_q);


/* get the queue mutex #access 
 * creat a new node and pass func,args,args_size 
 * add the new node to the queue
 * signal the thread pool if the queue was empty */
void job_submit(List *job_q,FuncPtr func,void* args,int args_size);



/* initiale the queue and thread pool 
 * returns a pointer to the initiated queue */
List * job_queue_init(int pool_size);

#ifdef __cplusplus
}
#endif

#endif
