/*
** $Id: key.h,v 1.5 2005/09/27 18:25:04 msa Exp $
**
** Matthew Allen
** description: 
*/

#ifndef CHIMERA_KEY_H
#define CHIMERA_KEY_H

#include <limits.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef unsigned long Key;
#define KEY_MAX ((Key) ULONG_MAX)
#define KEY_HALF ((Key) 2147483648)

/* converts a string into a hashed key */

Key key_makehash(char *s);

/* returns the absolute difference between k1 and k2 */

Key key_distance(Key k1, Key k2);

/* check to see if the value in test falls in the range from left clockwise
** around the ring to right. */

int key_between(Key test, Key left, Key right);

#ifdef __cplusplus
}
#endif

#endif /* CHIMERA_KEY_H */
