/*
** $Id: message.h,v 1.8 2005/09/27 18:25:04 msa Exp $
**
** Matthew Allen
** description: 
*/

#ifndef CHIMERA_MESSAGE_H
#define CHIMERA_MESSAGE_H

#include "key.h"
#include "host.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  Key dest;
  int type;
  int size;
  char *payload;
} Message;

typedef void (*messagehandler_t)(Message *);

int message_init(int port);
void message_recieved(char *data, int size);
void message_handler(int type, messagehandler_t func);
int message_send(ChimeraHost *host, Message *message);
Message *message_create(Key dest, int type, int size, char *payload);

#ifdef __cplusplus
}
#endif

#endif /* CHIMERA_MESSAGE_H */
