/*
** $Id: route.h,v 1.8 2005/09/27 18:25:04 msa Exp $
**
** Matthew Allen
** description: 
*/

#ifndef CHIMERA_ROUTE_H
#define CHIMERA_ROUTE_H

#include "chimera.h"

#ifdef __cplusplus
extern "C" {
#endif

/* Ininitiates routing table and leafsets */
void route_init(ChimeraHost *me);

/* returns an array of #count# nodes that are acceptable next hops for a
** message being routed to #key#. #is_save# is ignored for now. */

ChimeraHost **route_lookup(Key key, int count, int is_safe);

/* returns an array of #count# neighbor nodes. Should give priority to
** closer nodes */

ChimeraHost **route_neighbors(int count);

/* updated the routing table in regard to #host#. If the host is joining
** the network (and #joined# == 1), then it is added to the routing table
** if it is appropriate. If it is leaving the network (and #joined# == 0),
** then it is removed from the routing tables */
void route_update(ChimeraHost *host, int joined);


/* return the row in the routing table that matches the longest prefix with #key# */
ChimeraHost **route_row_lookup(Key key);


/* get host information and allocate memory for the input */
void gethostinfo(ChimeraHost *CHost);

/* returns all the entries in the routing table in an array of ChimeraHosts */
ChimeraHost **route_get_table(void);

/* print routing table */
void printTable();

#ifdef __cplusplus
}
#endif

#endif /* CHIMERA_ROUTE_H */
