/*
** $Id: key.c,v 1.7 2005/05/05 06:50:56 msa Exp $
**
** Matthew Allen
** description: 
*/

#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include "key.h"
#include "log.h"

Key key_makehash(char *s) {

  Key b    = 378551;
  Key a    = 63689;
  Key hash = 0;
  int i;

  for(i = 0; i < strlen(s); i++) {
    hash = hash + (a * (unsigned long) s[i]);
    a = a * b;
  }

  return((Key) hash);

}

Key key_distance(Key k1, Key k2) {

  Key diff;

  if(k1 > k2) {
    diff = k1 - k2;
  } else {
    diff = k2 - k1;
  }

  if(diff > (KEY_MAX / 2)) {
    diff = KEY_MAX - diff;
  }

  log_message(LOG_KEYDEBUG, "key_distance: %x and %x is %x\n", k1, k2, diff);

  return((Key) diff);

}

int key_between(Key test, Key left, Key right) {

  unsigned long t, l, r;

  l = 0;

  if(left < test) {
    t = test - left;
  } else {
    t = test + (KEY_MAX - left);
  }

  if(left < right) {
    r = right - left;
  } else {
    r = right + (KEY_MAX - left);
  }

  log_message(LOG_KEYDEBUG, "key_between: %x %s between %x and %x\n", test, (t<r)?("IS"):("NOT"), left, right);

  if(t < r) return(1);
  return(0);

}
